/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables;


import com.tabajara.base.Indexes;
import com.tabajara.base.Keys;
import com.tabajara.base.Public;
import com.tabajara.base.tables.records.CriacaoRecord;

import java.sql.Date;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Criacao extends TableImpl<CriacaoRecord> {

    private static final long serialVersionUID = -1527110953;

    /**
     * The reference instance of <code>public.criacao</code>
     */
    public static final Criacao CRIACAO = new Criacao();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<CriacaoRecord> getRecordType() {
        return CriacaoRecord.class;
    }

    /**
     * The column <code>public.criacao.criaid</code>.
     */
    public final TableField<CriacaoRecord, Integer> CRIAID = createField("criaid", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('criacao_criaid_seq'::regclass)", org.jooq.impl.SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>public.criacao.criaespecie</code>.
     */
    public final TableField<CriacaoRecord, String> CRIAESPECIE = createField("criaespecie", org.jooq.impl.SQLDataType.VARCHAR(50), this, "");

    /**
     * The column <code>public.criacao.criadata</code>.
     */
    public final TableField<CriacaoRecord, Date> CRIADATA = createField("criadata", org.jooq.impl.SQLDataType.DATE.defaultValue(org.jooq.impl.DSL.field("CURRENT_DATE", org.jooq.impl.SQLDataType.DATE)), this, "");

    /**
     * Create a <code>public.criacao</code> table reference
     */
    public Criacao() {
        this(DSL.name("criacao"), null);
    }

    /**
     * Create an aliased <code>public.criacao</code> table reference
     */
    public Criacao(String alias) {
        this(DSL.name(alias), CRIACAO);
    }

    /**
     * Create an aliased <code>public.criacao</code> table reference
     */
    public Criacao(Name alias) {
        this(alias, CRIACAO);
    }

    private Criacao(Name alias, Table<CriacaoRecord> aliased) {
        this(alias, aliased, null);
    }

    private Criacao(Name alias, Table<CriacaoRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, "");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return Public.PUBLIC;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.CRIACAO_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<CriacaoRecord, Integer> getIdentity() {
        return Keys.IDENTITY_CRIACAO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<CriacaoRecord> getPrimaryKey() {
        return Keys.CRIACAO_PKEY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<CriacaoRecord>> getKeys() {
        return Arrays.<UniqueKey<CriacaoRecord>>asList(Keys.CRIACAO_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Criacao as(String alias) {
        return new Criacao(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Criacao as(Name alias) {
        return new Criacao(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Criacao rename(String name) {
        return new Criacao(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Criacao rename(Name name) {
        return new Criacao(name, null);
    }
}
